diff --git a/drupal7/sites/all/modules/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php b/drupal7/sites/all/modules/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php
index f1b32c54..c959a6de 100644
--- a/drupal7/sites/all/modules/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php
+++ b/drupal7/sites/all/modules/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php
@@ -29,6 +29,7 @@ class panels_renderer_ipe extends panels_renderer_editor {
       '#type' => 'link',
       '#title' => t('Customize this page'),
       '#href' => $this->get_url('save_form'),
+      '#options' => array('query' => drupal_get_destination()),
       '#id' => 'panels-ipe-customize-page',
       '#attributes' => array(
         'class' => array('panels-ipe-startedit', 'panels-ipe-pseudobutton'),
@@ -49,6 +50,7 @@ class panels_renderer_ipe extends panels_renderer_editor {
         '#type' => 'link',
         '#title' => t('Change layout'),
         '#href' => $this->get_url('change_layout'),
+        '#options' => array('query' => drupal_get_destination()),
         '#attributes' => array(
           'class' => array('panels-ipe-change-layout', 'panels-ipe-pseudobutton', 'ctools-modal-layout'),
         ),
diff --git a/drupal7/sites/all/modules/panels/panels_mini/panels_mini.info b/drupal7/sites/all/modules/panels/panels_mini/panels_mini.info
index 628dcf07..46a6b406 100644
--- a/drupal7/sites/all/modules/panels/panels_mini/panels_mini.info
+++ b/drupal7/sites/all/modules/panels/panels_mini/panels_mini.info
@@ -1,12 +1,13 @@
 name = Mini panels
 description = Create mini panels that can be used as blocks by Drupal and panes by other panel modules.
 package = "Panels"
+version = PANELS_VERSION
 dependencies[] = panels
 core = 7.x
 files[] = plugins/export_ui/panels_mini_ui.class.php
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.4"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-3.5"
 core = "7.x"
 project = "panels"
-datestamp = "1392221614"
+datestamp = "1422472985"
 
diff --git a/drupal7/sites/all/modules/panels/panels_mini/panels_mini.module b/drupal7/sites/all/modules/panels/panels_mini/panels_mini.module
index 534916d8..f701893a 100644
--- a/drupal7/sites/all/modules/panels/panels_mini/panels_mini.module
+++ b/drupal7/sites/all/modules/panels/panels_mini/panels_mini.module
@@ -112,6 +112,7 @@ function panels_mini_block_view($delta = 0) {
       $contexts = ctools_context_match_required_contexts($panel_mini->requiredcontexts, $current_page['contexts']);
     }
   }
+  drupal_alter('panels_mini_block_contexts', $contexts, $panel_mini);
 
   $panel_mini->context = $panel_mini->display->context =  ctools_context_load_contexts($panel_mini, FALSE, $contexts);
   $panel_mini->display->css_id = panels_mini_get_id($panel_mini->name);
@@ -196,8 +197,8 @@ function panels_mini_get_pane_links_alter(&$links, $pane, $content_type) {
  */
 function panels_mini_contextual_links_view_alter(&$element, $items) {
 
-  // Add contextual links to all mini panel blocks.
-  if (isset($element['#element']['#block']) && strpos((string) $element['#element']['#block']->bid, 'panels_mini') === 0) {
+  // Add contextual links to all mini panel blocks with bid property.
+  if (isset($element['#element']['#block']) && isset($element['#element']['#block']->bid) && strpos((string) $element['#element']['#block']->bid, 'panels_mini') === 0) {
 
     $admin_pages = array(
       t('Configure mini panel settings') => 'basic',
@@ -518,3 +519,14 @@ function panels_mini_panels_dashboard_blocks(&$vars) {
   );
 
 }
+
+/**
+ * Implements template_preprocess_ctools_wizard_trail().
+ *
+ * Customize the divider used in the CTools wizard to build the edit pages for
+ * Mini Panels as a stop-gap measure until the UX can be completely re-done.
+ */
+function panels_mini_preprocess_ctools_wizard_trail(&$variables) {
+  $variables['divider'] = ' | ';
+  drupal_add_css(drupal_get_path('module', 'panels_mini') . '/panels_mini.css');
+}
diff --git a/drupal7/sites/all/modules/panels/panels_node/panels_node.info b/drupal7/sites/all/modules/panels/panels_node/panels_node.info
index 78591e59..407c9f4f 100644
--- a/drupal7/sites/all/modules/panels/panels_node/panels_node.info
+++ b/drupal7/sites/all/modules/panels/panels_node/panels_node.info
@@ -1,14 +1,15 @@
 name = Panel nodes
 description = Create nodes that are divided into areas with selectable content.
 package = "Panels"
+version = PANELS_VERSION
 dependencies[] = panels
 configure = admin/structure/panels
 core = 7.x
 files[] = panels_node.module
 
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.4"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-3.5"
 core = "7.x"
 project = "panels"
-datestamp = "1392221614"
+datestamp = "1422472985"
 
diff --git a/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php b/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php
index 4876ff38..a814eb7f 100644
--- a/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php
+++ b/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php
@@ -161,7 +161,7 @@ class panels_renderer_editor extends panels_renderer_standard {
     if ($buttons) {
       $output .= '<span class="buttons">' . $buttons . '</span>';
     }
-    $output .= '<span class="text">' . $title . '</span>';
+    $output .= '<span class="text" title="' . check_plain($title) . '">' . $title . '</span>';
     $output .= '</div>'; // grabber
 
     $output .= '<div class="panel-pane-collapsible">';
@@ -467,21 +467,24 @@ class panels_renderer_editor extends panels_renderer_standard {
     drupal_alter('get_pane_links', $links, $pane, $content_type);
 
     $dropdown_links = $links['top'];
-    foreach (array(
-  'style' => 'Style',
-  'visibility' => 'Visibility rules',
-  'lock' => 'Locking',
-  'cache' => 'Caching'
-    ) as $category => $label) {
-      $dropdown_links[] = array(
-        'title' => '<hr />',
-        'html' => TRUE,
-      );
-      $dropdown_links[] = array(
-        'title' => '<span class="dropdown-header">' . t($label) . '</span>' . theme_links(array('links' => $links[$category], 'attributes' => array(), 'heading' => array())),
-        'html' => TRUE,
-        'attributes' => array('class' => array('panels-sub-menu')),
-      );
+    $category_labels = array(
+      'style' => 'Style',
+      'visibility' => 'Visibility rules',
+      'lock' => 'Locking',
+      'cache' => 'Caching',
+    );
+    foreach ($category_labels as $category => $label) {
+      if (array_key_exists($category, $links)) {
+        $dropdown_links[] = array(
+          'title' => '<hr />',
+          'html' => TRUE,
+        );
+        $dropdown_links[] = array(
+          'title' => '<span class="dropdown-header">' . t($label) . '</span>' . theme_links(array('links' => $links[$category], 'attributes' => array(), 'heading' => array())),
+          'html' => TRUE,
+          'attributes' => array('class' => array('panels-sub-menu')),
+        );
+      }
     }
 
     $dropdown_links[] = array(
@@ -944,8 +947,11 @@ class panels_renderer_editor extends panels_renderer_standard {
         ctools_include('content');
         $pane = &$this->display->content[$pid];
         $style = isset($pane->style['style']) ? $pane->style['style'] : 'default';
-        $subtype = ctools_content_get_subtype($pane->type, $pane->subtype);
-        $title = t('Pane style for "!pane"', array('!pane' => $subtype['title']));
+        $title = ctools_content_admin_title($pane->type, $pane->subtype, $pane->configuration, $this->display->context);
+        if (!$title) {
+          $title = $pane->type;
+        }
+        $title = t('Pane style for "!title"', array('!title' => $title));
         break;
 
       default:
@@ -1160,9 +1166,21 @@ class panels_renderer_editor extends panels_renderer_standard {
       unset($this->cache->style);
     }
 
+    if (!empty($form_state['cancel'])) {
+      // The cache must be saved prior to dismissing the modal.
+      panels_edit_cache_set($this->cache);
+      $this->commands[] = ctools_modal_command_dismiss();
+      return;
+    }
+
     // Copy settings from form state back into the cache.
     if(!empty($form_state['values']['settings'])) {
-      $this->cache->display->content[$pid]->style['settings'] = $form_state['values']['settings'];
+      if ($type == 'pane') {
+        $this->cache->display->content[$pid]->style['settings'] = $form_state['values']['settings'];
+      }
+      else if($type == 'region') {
+        $this->cache->display->panel_settings['style_settings'][$pid] = $form_state['values']['settings'];
+      }
     }
 
     panels_edit_cache_set($this->cache);
@@ -1697,9 +1715,28 @@ function panels_edit_style_settings_form($form, &$form_state) {
     '#value' => t('Save'),
   );
 
+
+  // Need a cancel button since the style cache can persist and impact the wrong
+  // pane (or region, or display).
+  $form['cancel_style'] = array(
+    '#type' => 'submit',
+    '#value' => t('Cancel'),
+    '#submit' => array('panels_edit_style_settings_form_cancel'),
+  );
+
   return $form;
 }
 
+/**
+ * Cancel style settings form.
+ *
+ * Clears the editing cache to prevent styles being applied to incorrect regions
+ * or panes.
+ */
+function panels_edit_style_settings_form_cancel($form, &$form_state) {
+  $form_state['cancel'] = TRUE;
+}
+
 /**
  * Validate style settings.
  */
diff --git a/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php b/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php
index db71b6bd..1de5bf41 100644
--- a/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php
+++ b/drupal7/sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php
@@ -407,14 +407,23 @@ class panels_renderer_standard {
    * their CSS added in the right order: inner content before outer content.
    */
   function add_meta() {
+    global $theme;
+
     if (!empty($this->plugins['layout']['css'])) {
+      // Do not use the path_to_theme() function, because it returns the
+      // $GLOBALS['theme_path'] value, which may be overriden in the theme()
+      // function when the theme hook defines the key 'theme path'.
+      $theme_path = isset($theme) ? drupal_get_path('theme', $theme) : '';
+
       $css = $this->plugins['layout']['css'];
       if (!is_array($css)) {
         $css = array($css);
       }
-      foreach($css as $file) {
-        if (file_exists(path_to_theme() . '/' . $file)) {
-          $this->add_css(path_to_theme() . '/' . $file);
+
+      // Load each of the CSS files defined in this layout.
+      foreach ($css as $file) {
+        if (!empty($theme_path) && file_exists($theme_path . '/' . $file)) {
+          $this->add_css($theme_path . '/' . $file);
         }
         else {
           $this->add_css($this->plugins['layout']['path'] . '/' . $file);
@@ -427,7 +436,7 @@ class panels_renderer_standard {
       if (!is_array($admin_css)) {
         $admin_css = array($admin_css);
       }
-      foreach($admin_css as $file) {
+      foreach ($admin_css as $file) {
         $this->add_css($this->plugins['layout']['path'] . '/' . $file);
       }
     }
diff --git a/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible-admin.js b/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible-admin.js
index 910b3c8e..2cddd42d 100644
--- a/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible-admin.js
+++ b/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible-admin.js
@@ -17,7 +17,7 @@ Drupal.flexible.fixHeight = function() {
 Drupal.behaviors.flexibleAdmin = {
   attach: function(context) {
     // Show/hide layout manager button
-    $('input#panels-flexible-toggle-layout:not(.panels-flexible-processed)', context)
+    $('#panels-flexible-toggle-layout:not(.panels-flexible-processed)', context)
       .addClass('panels-flexible-processed')
       .click(function() {
         $('.panel-flexible-admin')
diff --git a/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible.inc b/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible.inc
index f49886bf..4cdb216b 100644
--- a/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible.inc
+++ b/drupal7/sites/all/modules/panels/plugins/layouts/flexible/flexible.inc
@@ -471,15 +471,26 @@ function panels_flexible_render_items($renderer, $list, $owner_id) {
     switch ($item['type']) {
       case 'column':
         $content = panels_flexible_render_items($renderer, $item['children'], $renderer->base['column'] . '-' . $id);
-        $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max);
+        if (empty($renderer->settings['items'][$id]['hide_empty']) || trim($content)) {
+          $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max);
+        }
         break;
       case 'row':
         $content = panels_flexible_render_items($renderer, $item['children'], $renderer->base['row'] . '-' . $id);
-        $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max, TRUE);
+        if (empty($renderer->settings['items'][$id]['hide_empty']) || trim($content)) {
+          $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max, TRUE);
+        }
         break;
       case 'region':
-        $content = isset($renderer->content[$id]) ? $renderer->content[$id] : "&nbsp;";
-        $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max);
+        if (empty($renderer->settings['items'][$id]['hide_empty'])) {
+          $content = isset($renderer->content[$id]) ? $renderer->content[$id] : "&nbsp;";
+        }
+        else {
+          $content = isset($renderer->content[$id]) ? trim($renderer->content[$id]) : "";
+        }
+        if (empty($renderer->settings['items'][$id]['hide_empty']) || $content) {
+          $groups[$location] .= panels_flexible_render_item($renderer, $item, $content, $id, $position, $max);
+        }
         break;
     }
 
@@ -1186,6 +1197,12 @@ function panels_flexible_config_item_form($form, &$form_state) {
     }
   }
 
+  $form['hide_empty'] = array(
+    '#title' => t('Hide element if empty'),
+    '#type' => 'checkbox',
+    '#default_value' => !empty($item['hide_empty']) ? 1 : 0,
+  );
+
   $form['save'] = array(
     '#type' => 'submit',
     '#value' => t('Save'),
@@ -1223,6 +1240,7 @@ function panels_flexible_config_item_form_submit(&$form, &$form_state) {
   else {
     $item['contains'] = $form_state['values']['contains'];
   }
+  $item['hide_empty'] = $form_state['values']['hide_empty'];
 
 }
 
@@ -1486,6 +1504,12 @@ function panels_flexible_add_item_form($form, &$form_state) {
     );
   }
 
+  $form['hide_empty'] = array(
+    '#title' => t('Hide element if empty'),
+    '#type' => 'checkbox',
+    '#default_value' => 0,
+  );
+
   $form['save'] = array(
     '#type' => 'submit',
     '#value' => t('Save'),
@@ -1516,6 +1540,8 @@ function panels_flexible_add_item_form_submit(&$form, &$form_state) {
     $item['contains'] = $form_state['values']['contains'];
   }
 
+  $item['hide_empty'] = $form_state['values']['hide_empty'];
+
   if ($item['type'] == 'region') {
     // derive the region key from the title
     $key = preg_replace("/[^a-z0-9]/", '_', drupal_strtolower($item['title']));
diff --git a/drupal7/sites/all/modules/panels/plugins/task_handlers/panel_context.inc b/drupal7/sites/all/modules/panels/plugins/task_handlers/panel_context.inc
index c3bb07fb..9f03b554 100644
--- a/drupal7/sites/all/modules/panels/plugins/task_handlers/panel_context.inc
+++ b/drupal7/sites/all/modules/panels/plugins/task_handlers/panel_context.inc
@@ -317,11 +317,21 @@ function panels_panel_context_render($handler, $base_contexts, $args, $test = TR
   // Remove and add body element classes
   $panel_body_css = &drupal_static('panel_body_css');
 
-  if (isset($handler->conf['body_classes_to_remove']) && !isset($panel_body_css['body_classes_to_remove'])) {
-    $panel_body_css['body_classes_to_remove'] = $handler->conf['body_classes_to_remove'];
+  if (isset($handler->conf['body_classes_to_remove'])) {
+    if (!isset($panel_body_css['body_classes_to_remove'])) {
+      $panel_body_css['body_classes_to_remove'] = $handler->conf['body_classes_to_remove'];
+    }
+    else{
+      $panel_body_css['body_classes_to_remove'] .= ' ' . $handler->conf['body_classes_to_remove'];
+    }
   }
-  if (isset($handler->conf['body_classes_to_add']) && !isset($panel_body_css['body_classes_to_add'])) {
-    $panel_body_css['body_classes_to_add'] = $handler->conf['body_classes_to_add'];
+  if (isset($handler->conf['body_classes_to_add'])) {
+    if (!isset($panel_body_css['body_classes_to_add'])) {
+      $panel_body_css['body_classes_to_add'] = $handler->conf['body_classes_to_add'];
+    }
+    else {
+      $panel_body_css['body_classes_to_add'] .= ' '. $handler->conf['body_classes_to_add'];
+    }
   }
 
   $info = array(
@@ -763,7 +773,7 @@ function panels_panel_context_edit_settings($form, &$form_state) {
   $form['conf']['body_classes_to_remove'] = array(
     '#type' => 'textfield',
     '#size' => 128,
-    '#default_value' => $conf['body_classes_to_remove'],
+    '#default_value' => empty($conf['body_classes_to_remove']) ? '' : $conf['body_classes_to_remove'],
     '#title' => t('Remove body CSS classes'),
     '#description' => t('The CSS classes to remove from the body element of this page. Separated by a space. For example: no-sidebars one-sidebar sidebar-first sidebar-second two-sidebars.'),
   );
@@ -771,7 +781,7 @@ function panels_panel_context_edit_settings($form, &$form_state) {
   $form['conf']['body_classes_to_add'] = array(
     '#type' => 'textfield',
     '#size' => 128,
-    '#default_value' => $conf['body_classes_to_add'],
+    '#default_value' => empty($conf['body_classes_to_add']) ? '' : $conf['body_classes_to_add'],
     '#title' => t('Add body CSS classes'),
     '#description' => t('The CSS classes to add to the body element of this page. Separated by a space. For example: no-sidebars one-sidebar sidebar-first sidebar-second two-sidebars.'),
   );
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc b/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
index e1b0b542..e9146193 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
@@ -256,6 +256,12 @@ function webform_validation_manage_rule($form, $form_state, $node, $action = 'ad
     '#weight' => 25,
   );
 
+  $destination = drupal_get_destination();
+  $form['rule']['cancel'] = array(
+    '#markup' => l(t('Cancel'), $destination['destination']),
+    '#weight' => 26,
+  );
+
   return $form;
 }
 
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.info b/drupal7/sites/all/modules/webform_validation/webform_validation.info
index d3afd9f6..d4bc3686 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.info
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.info
@@ -11,9 +11,9 @@ files[] = webform_validation.module
 files[] = webform_validation.rules.inc
 files[] = webform_validation.validators.inc
 
-; Information added by Drupal.org packaging script on 2014-09-09
-version = "7.x-1.7"
+; Information added by Drupal.org packaging script on 2015-01-23
+version = "7.x-1.8"
 core = "7.x"
 project = "webform_validation"
-datestamp = "1410296269"
+datestamp = "1422027782"
 
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.module b/drupal7/sites/all/modules/webform_validation/webform_validation.module
index e86ba311..5cd5ab45 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.module
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.module
@@ -5,8 +5,8 @@
  * Add validation rules to webforms
  */
 
-include_once DRUPAL_ROOT . '/' . drupal_get_path('module', 'webform_validation') . '/' . 'webform_validation.validators.inc';
-include_once DRUPAL_ROOT . '/' . drupal_get_path('module', 'webform_validation') . '/' . 'webform_validation.rules.inc';
+include_once('webform_validation.validators.inc');
+include_once('webform_validation.rules.inc');
 
 /**
  * Implements hook_menu().
@@ -153,6 +153,13 @@ function webform_validation_validate($form, &$form_state) {
   }
 
   if ($rules) {
+    $component_definitions = webform_validation_prefix_keys($node->webform['components']);
+    // Remove hidden components.
+    foreach ($component_definitions as $key => $component) {
+      if (_webform_client_form_rule_check($node, $component, 0, $form_state['values']['submitted']) !== WEBFORM_CONDITIONAL_INCLUDE) {
+        unset($flat_values[$key]);
+      }
+    }
     foreach ($rules as $rule) {
       // create a list of components that need validation against this rule (component id => user submitted value)
       $items = array();
@@ -163,7 +170,6 @@ function webform_validation_validate($form, &$form_state) {
       }
       // prefix array keys to avoid reindexing by the module_invoke_all function call
       $items = webform_validation_prefix_keys($items);
-      $component_definitions = webform_validation_prefix_keys($node->webform['components']);
       $rule['sid'] = $sid;
       // have the submitted values validated
       $errors = module_invoke_all("webform_validation_validate", $rule['validator'], $items, $component_definitions, $rule);
@@ -302,7 +308,7 @@ function theme_webform_validation_manage_add_rule($variables) {
  */
 function webform_validation_webform_validation($type, $op, $data) {
   if ($type == 'rule' && in_array($op, array('add', 'edit'))) {
-    if (module_exists('i18n') && isset($data['error_message'])) {
+    if (module_exists('i18n_string') && isset($data['error_message'])) {
       i18n_string_update('webform_validation:error_message:' . $data['ruleid'] . ':message', $data['error_message']);
     }
   }
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.validators.inc b/drupal7/sites/all/modules/webform_validation/webform_validation.validators.inc
index ce4e28e2..363ba8ce 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.validators.inc
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.validators.inc
@@ -146,7 +146,7 @@ function webform_validation_webform_validation_validators() {
       ),
       'min_components' => 2,
       'max_components' => 2,
-      'description' => t('Compare two values for greater than or less than, or equal to.'),
+      'description' => t('Compare two values for greater than (>), less than (<), greater than or equal to (>=), or less than or equal to (<=).'),
     ),
     'unique' => array(
       'name' => t('Unique values'),
@@ -446,6 +446,8 @@ function webform_validation_webform_validation_validate($validator_name, $items,
     }
     $items[$key] = $new_values;
   }
+  // Ensure later calls to key() get the first item.
+  reset($items);
 
   $errors = array();
   switch ($validator_name) {
diff --git a/drupal7/sites/all/themes/adminimal_theme/adminimal.info b/drupal7/sites/all/themes/adminimal_theme/adminimal.info
index aab9e58e..95cf268c 100644
--- a/drupal7/sites/all/themes/adminimal_theme/adminimal.info
+++ b/drupal7/sites/all/themes/adminimal_theme/adminimal.info
@@ -20,9 +20,9 @@ regions[page_bottom] = Page bottom
 regions[sidebar_first] = First sidebar
 regions_hidden[] = sidebar_first
 
-; Information added by Drupal.org packaging script on 2015-01-17
-version = "7.x-1.19"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.20"
 core = "7.x"
 project = "adminimal_theme"
-datestamp = "1421496186"
+datestamp = "1422442296"
 
diff --git a/drupal7/sites/all/themes/adminimal_theme/js/adminimal_theme.js b/drupal7/sites/all/themes/adminimal_theme/js/adminimal_theme.js
index b93d3674..264230d8 100644
--- a/drupal7/sites/all/themes/adminimal_theme/js/adminimal_theme.js
+++ b/drupal7/sites/all/themes/adminimal_theme/js/adminimal_theme.js
@@ -77,11 +77,11 @@ Drupal.behaviors.adminimal_move_active_primary_tab = {
 			breakpoint: 'mobile',
 				enter: function() {
 					$( "ul.tabs.primary li.active" ).clone().appendTo( "ul.tabs.primary" ).removeClass( "active" ).addClass( "current" );
-					$( "ul.tabs.primary li.active" ).hide();
+					$( "ul.tabs.primary li.active" ).css("display", "none");
 				},
 				exit: function() {
-					$( "ul.tabs.primary li.active" ).show();
-					$( "ul.tabs.primary li.current" ).hide();
+					$( "ul.tabs.primary li.active" ).css("display", "table");
+					$( "ul.tabs.primary li.current" ).css("display", "none");
 				}
 		});
 	}
diff --git a/drupal7/sites/all/themes/adminimal_theme/template.php b/drupal7/sites/all/themes/adminimal_theme/template.php
index 1403ca50..0c706777 100644
--- a/drupal7/sites/all/themes/adminimal_theme/template.php
+++ b/drupal7/sites/all/themes/adminimal_theme/template.php
@@ -61,7 +61,7 @@ function adminimal_preprocess_html(&$vars) {
   drupal_add_css($adminimal_path . '/css/tablet.css', array('group' => CSS_THEME, 'media' => $media_query_tablet, 'weight' => 1000));
 
   // Add custom CSS.
-  $custom_css_path = $adminimal_path . '/css/custom.css'; 
+  $custom_css_path = 'public://adminimal-custom.css';
   if (theme_get_setting('custom_css') && file_exists($custom_css_path)) {
     drupal_add_css($custom_css_path, array('group' => CSS_THEME, 'weight' => 9999, 'preprocess' => FALSE));
   }
diff --git a/drupal7/sites/all/themes/adminimal_theme/theme-settings.php b/drupal7/sites/all/themes/adminimal_theme/theme-settings.php
index e83bc334..904c00be 100644
--- a/drupal7/sites/all/themes/adminimal_theme/theme-settings.php
+++ b/drupal7/sites/all/themes/adminimal_theme/theme-settings.php
@@ -17,8 +17,31 @@
 function adminimal_form_system_theme_settings_alter(&$form, &$form_state) {
 
   // Get adminimal theme path.
+  global $base_url;
   $adminimal_path = drupal_get_path('theme', 'adminimal');
-  $custom_css_path = $adminimal_path . '/css/custom.css';
+  $old_css_path = $adminimal_path . '/css/custom.css';
+  $custom_css_path = 'public://adminimal-custom.css';
+  $custom_css_dir = str_replace($base_url . '/', "", file_create_url($custom_css_path));
+  $custom_css_url = file_create_url($custom_css_path);
+
+  // Try to create the adminimal-custom.css file automatically.
+  if (!file_exists($custom_css_path)) {
+
+    // Try to migrate from the old css.
+    if (file_exists($old_css_path)) {
+      file_unmanaged_copy($old_css_path, $custom_css_path, FILE_EXISTS_ERROR);
+    }
+    // Else create e new blank css file.
+    else {
+      file_unmanaged_save_data("", $custom_css_path, FILE_EXISTS_ERROR);
+    }
+
+  }
+
+  // Notify user to remove his old css file.
+  if (file_exists($old_css_path)) {
+    drupal_set_message(t('Please delete the old @css_location file, as its no longer used.', array('@css_location file' => $old_css_path)), 'warning');
+  }
 
   $form['adminimal_custom'] = array(
     '#type' => 'fieldset',
@@ -66,9 +89,8 @@ function adminimal_form_system_theme_settings_alter(&$form, &$form_state) {
 
   $form['adminimal_custom']['custom_css'] = array(
     '#type' => 'checkbox',
-    '#title' => t('Use "custom.css"'),
-    '#description' => t('Include custom.css file to override default Adminimal styles
-     or add additional styles without subthememing/hacking Adminimal Theme.'),
+    '#title' => t('Use "adminimal-custom.css"'),
+    '#description' => t('Include adminimal-custom.css file to override or add custom css code without subthememing/hacking Adminimal Theme.'),
     '#default_value' => theme_get_setting('custom_css'),
   );
 
@@ -86,14 +108,14 @@ function adminimal_form_system_theme_settings_alter(&$form, &$form_state) {
 
   if (file_exists($custom_css_path)) {
     $form['adminimal_custom']['adminimal_custom_check']['custom_css_description'] = array(
-      '#markup' => t('Custom CSS file Found in: !css', array('!css' => "<span class='css_path'>" . $custom_css_path . "</span>")),
+      '#markup' => t('Custom CSS file Found in: !css', array('!css' => "<span class='css_path'>" . $custom_css_dir . "</span>")),
       '#prefix' => '<div class="messages status custom_css_found">',
       '#suffix' => '</div>',
     );
   }
   else {
     $form['adminimal_custom']['adminimal_custom_check']['custom_css_not_found'] = array(
-      '#markup' => t('Custom CSS file not found. You must create the !css file manually.', array('!css' => "<span class='css_path'>" . $custom_css_path . "</span>")),
+      '#markup' => t('Custom CSS file not found. You must create the !css file manually.', array('!css' => "<span class='css_path'>" . $custom_css_dir . "</span>")),
       '#prefix' => '<div class="messages error custom_css_not_found">',
       '#suffix' => '</div>',
     );
